package fishrungames.yelpmapapp

import android.support.v4.app.Fragment
import android.os.Bundle
import android.support.v7.widget.LinearLayoutCompat
import android.support.v7.widget.LinearLayoutManager

import android.view.ViewGroup
import android.view.LayoutInflater
import android.view.View
import fishrungames.yelpmapapp.records.BusinessDetailRecord
import fishrungames.yelpmapapp.records.ReviewListRecord
import android.support.v7.widget.RecyclerView
import fishrungames.yelpmapapp.records.MapMarkerRecord


/**
 * Created by mephi on 10.06.2017.
 */

class DetailFragment : Fragment()
{

    var detailRecyclerAdapter : DetailRecyclerAdapter? = null

    var mapMarkerRecord : MapMarkerRecord? = null

    override fun onCreateView(inflater: LayoutInflater?, container: ViewGroup?, savedInstanceState: Bundle?): View? {

        val rootView = inflater!!.inflate(R.layout.detail_fragment, container, false)

        val detailRecyclerView = rootView.findViewById(R.id.detailRecyclerView) as RecyclerView

        detailRecyclerView.layoutManager = LinearLayoutManager(this.context)

        mapMarkerRecord = arguments?.getSerializable("mapMarkerRecord") as? MapMarkerRecord

        if (mapMarkerRecord != null && mapMarkerRecord!!.id != null) {

            detailRecyclerAdapter = DetailRecyclerAdapter()

            detailRecyclerView.adapter = detailRecyclerAdapter

            (activity as? YelpMapActivity)?.dataProvider?.requestBusinessDetail(mapMarkerRecord!!.id!!)
            (activity as? YelpMapActivity)?.dataProvider?.requestReviewList(mapMarkerRecord!!.id!!)

        }

        return rootView
    }

    fun updateBusinessDetail(businessDetailRecord : BusinessDetailRecord)
    {
        detailRecyclerAdapter?.notifyDataSetChanged()
    }

    fun  updateReviewList(reviewListRecordPair : Pair<String, ReviewListRecord>)
    {
        detailRecyclerAdapter?.notifyDataSetChanged()
    }
}