package fishrungames.yelpmapapp.asyncTasks

import android.os.AsyncTask
import com.google.gson.JsonObject
import com.google.gson.Gson
import com.google.gson.reflect.TypeToken
import fishrungames.yelpmapapp.records.BusinessDetailRecord
import fishrungames.yelpmapapp.records.MapMarkerRecord
import fishrungames.yelpmapapp.records.ReviewListRecord


/**
 * Created by mephi on 10.06.2017.
 */


class HandleReviewListResponseAsyncTask(val id: String, val onUpdateReviewList : ((Pair<String, ReviewListRecord>?) -> Unit)) : AsyncTask<JsonObject, Int, Pair<String, ReviewListRecord>?>()
{


    override fun doInBackground(vararg response : JsonObject): Pair<String, ReviewListRecord>? {

        var resultPair : Pair<String, ReviewListRecord>? = null

        try {

            val recordType = object : TypeToken<BusinessDetailRecord?>() {}.type

            val result = Gson().fromJson<ReviewListRecord?>(response[0], recordType)

            if (result != null)
            {
                resultPair = Pair<String, ReviewListRecord>(id, result);
            }

        }
        catch (e : Exception)
        {
            e.printStackTrace()

        }

        return resultPair
    }

    override fun onPostExecute(result: Pair<String, ReviewListRecord>?) {

        super.onPostExecute(result)

        onUpdateReviewList(result)

    }
}